// Exam #2 Question 4

import java.util.ArrayList;

public class Graph
{
  /********************* Part (a) *********************/

  /** Returns true if the graph represented by the
   *  given adjacency matrix is a complete graph; otherwise
   *  returns false.
   */ 
  public static boolean isComplete(int[][] m)
  {
    int n = m.length;
    
    for (int i = 0; i < n; i++)
    {
      if (m[i][i] != 0)
        return false;
    }

    for (int i = 0; i < n; i++)
    {
      for (int j = 0; j < i; j++)
      {
        if (m[i][j] != 1 || m[j][i] != 1)
          return false;
      }
    }
    return true;
  } 

  /********************* Part (b) *********************/

  /** Returns the adjacency matrix of the graph represented by
   *  a list of its vertices and a string of its edges. The
   *  vertices are single letters, and the edges are
   *  two-letter substrings of edges, separated by spaces.
   */ 
  public static int[][] makeAdjacencyMatrix(
           ArrayList<String> vertices, String edges)
  {
    int n = vertices.size();
    int[][] m = new int[n][n];
    
    for (int i = 0; i < n; i++)
    {
      for (int j = 0; j < n; j++)
      {
        String letter1 = vertices.get(i);
        String letter2 = vertices.get(j);
        if (edges.indexOf(letter1 + letter2) >= 0)
        {
          m[i][j] = 1;
          m[j][i] = 1;
        }
      }
    }
    return m;
  }

  /*********************  Extra  **********************/  

  public static boolean isCycle(int[][] m)
  {
    ...
  }
}
