import java.util.ArrayList;

public class TestGraph
{
  public static void main(String[] args)
  {
    ArrayList<String> vertices = new ArrayList<String>();
    vertices.add("A");
    vertices.add("B");
    vertices.add("C");
    vertices.add("D");
    String edges = "AB BC BD CD";

    int[][] m = Graph.makeAdjacencyMatrix(vertices, edges);
    for (int[] row : m)
    {
      for (int a : row)
        System.out.print(a + " ");
      System.out.println();
    } 
    System.out.println();

    System.out.print(Graph.isComplete(m) + " ");
    edges += " AC";
    edges += " AD";
    m = Graph.makeAdjacencyMatrix(vertices, edges);
    System.out.print(Graph.isComplete(m) + " ");
    edges += " AA";
    m = Graph.makeAdjacencyMatrix(vertices, edges);
    System.out.print(Graph.isComplete(m) + " ");
    System.out.println();
    
    vertices.add("E");
    vertices.add("F");
    
    edges = "AB BC CD DE EF FA";
    m = Graph.makeAdjacencyMatrix(vertices, edges);
    System.out.print(Graph.isCycle(m) + " ");
    
    edges = "AB BC CD DE EF FA AD";
    m = Graph.makeAdjacencyMatrix(vertices, edges);
    System.out.print(Graph.isCycle(m) + " ");

    edges = "AB BC CD DE EF";
    m = Graph.makeAdjacencyMatrix(vertices, edges);
    System.out.print(Graph.isCycle(m) + " ");
    
    edges = "AB BC CD DE EF AD";
    m = Graph.makeAdjacencyMatrix(vertices, edges);
    System.out.print(Graph.isCycle(m) + " ");

    edges = "AB BC CA DE EF FD";
    m = Graph.makeAdjacencyMatrix(vertices, edges);
    System.out.print(Graph.isCycle(m) + " ");

    edges = "AB BC CD DE EF FB";
    m = Graph.makeAdjacencyMatrix(vertices, edges);
    System.out.print(Graph.isCycle(m) + " ");

    edges = "AB BF FC CE ED DA";
    m = Graph.makeAdjacencyMatrix(vertices, edges);
    System.out.print(Graph.isCycle(m) + " ");
    System.out.println();
  }
}