// Exam #3 Question 1

public class Bus
{
  /** Starting and ending times of the bus schedule
      (in minutes since midnight) at a particular bus stop */
  private int startTime, endTime;

  /** The interval between two consecutive buses (in minutes) */  
  private int runInterval;

  /********************* Part (a) *********************/

  /** Constructs a Bus object with given starting and
   *  ending times and a given interval between two
   *  consecutive buses. The start and end strings represent
   *  time in the 24-hour format.
   */  
  public Bus(String start, String end, int mins)
  {
    startTime = toMinutes(start);
    endTime = toMinutes(end);
    runInterval = mins;
  }

  /****************************************************/
  
  /** Converts a string that represents time in the 24-hour
   *  format into minutes since midnight and returns the
   *  result.
   */
  private int toMinutes(String time)
  {
    ...
  }

  /********************* Part (b) *********************/

  /** Returns the wait time for the next bus from a given
   *  time. The parameter time is a string that represents
   *  time in the 24-hour format. If time exceeds the time
   *  of the final bus, the method returns -1.  
   */
  public int waitTime(String time)
  {
    int now = toMinutes(time);
    int nextBus = startTime;
    while (nextBus < now)
      nextBus += runInterval;
    if (nextBus > endTime)
      return -1;
    return nextBus - now;
  }
}