// Exam #4 Question 4

public class Highway
{
  /** hwy[lane][x] = 1 if there is a car at position x
   *  in lane; hwy[lane][x] = 0 if there is no car. */
  private int[][] hwy;

  /** Constructs an empty Highway with a given number of
   *  lanes and a given length. 
   */
  public Highway(int lanes, int length)
  {
    ...
  }

  /** Places a car in a given lane at a given position. */
  public void addCar(int lane, int x)
  {
    ...
  }

  /********************* Part (a) *********************/

  /** A car can switch to an adjacent lane if that lane is
   *  within hwy bounds and there are no cars at the same
   *  position in other lanes in the direction of the lateral
   *  move.
   */
  public boolean canSwitchLane(int lane, int dir, int x)
  {
    int lanes = hwy.length;

    int newLane = lane + dir;
    if (newLane < 0 || newLane >= lanes)
      return false;

    while (newLane >= 0 && newLane < lanes)
    {
      if (hwy[newLane][x] != 0)
        return false;
      newLane += dir;
    }
    return true;
  }

  /********************* Part (b) *********************/

  /** Moves all cars in all lanes forward by one position;
   *  a car in the last (rightmost) position moves into the
   *  first position (position 0) in the same lane.
   */
  public void moveAllForward()
  {
    int xMax = hwy[0].length - 1;
    
    for (int lane = 0; lane < hwy.length; lane++)
    {
      int saved = hwy[lane][xMax];

      for (int x = xMax; x > 0; x--)
        hwy[lane][x] = hwy[lane][x-1];

      hwy[lane][0] = saved;
    }
  }

  /*********************  Extra  *********************/

  /** All cars in hwy attempt to switch lanes with
   *  the probability 0.1 up and the same probability
   *  down; all cars that can make such a lateral move
   *  do so.
   */
  public void moveAllSideways()
  {
    ...
  }

  /** Moves each car half way toward the current position of the next car in the same lane.
   *  If a car has no other cars in front of it, use the first car in its lane as the next car.
   */
  public void moveAllForward2()
  {
    ...
  }

  /********************* toString *********************/

  public String toString()
  {
    String s = "";
    for (int lane = 0; lane < hwy.length; lane++)
    {
      for (int x = 0; x < hwy[0].length; x++)
      {
        if (hwy[lane][x] == 1)
          s += "x";
        else
          s += ".";
      }
      s += "\n";
    }
    return s;
  }
}
