// Exam #5 Question 4

import java.util.ArrayList;

public class Chess
{
  /********************* Part (a) *********************/

  /** Returns an 8-by-8 boolean two-dimensional array in which
   *  the element at row, col and all the elements that
   *  represent positions reachable by a queen placed at row,
   *  col are set to true, and all the other elements are set
   *  to false.
   *  Precondition: 0 <= row < 8; 0 <= col < 8
   */
  public static boolean[][] oneQueen(int row, int col)
  {
    boolean[][] board = new boolean[8][8];
        
    for (int k = 0; k < 8; k++)
    {
      board[row][k] = true;
      board[k][col] = true;
    }

    for (int k = -7; k < 8; k++)
    {
      int r, c;
      
      r = row + k;
      c = col + k;
      if (0 <= r && r < 8 && 0 <= c && c < 8)
        board[r][c] = true;

      r = row + k;
      c = col - k;
      if (0 <= r && r < 8 && 0 <= c && c < 8)
        board[r][c] = true;
    }
    return board;
  }

  /********************* Part (b) *********************/

  /** Returns an 8-by-8 boolean two-dimensional array in which
   *  the element at row1, col1, the element at row2, col2,
   *  and all the elements that represent positions reachable
   *  by a queen placed at row1, col1 as well as positions
   *  reachable by a queen placed at row2, col2 are set to
   *  true, and all the other elements are set to false.
   *  Precondition: 0 <= row1 < 8; 0 <= col1 < 8;
   *                0 <= row2 < 8; 0 <= col2 < 8
   */
  public static boolean[][] twoQueens(int row, int col,
                                           int row2, int col2)
  {
    boolean[][] board = oneQueen(row, col);
    boolean[][] board2 = oneQueen(row2, col2);

    for (int r = 0; r < 8; r++)
    {
      for (int c = 0; c < 8; c++)
        board[r][c] = board[r][c] || board2[r][c];
    }
    return board;
  }
  
  /*********************  Extra  *********************/
  
  /** Returns true if there is a position on the board that 
   *  none of the queens in positions from the queens list can reach;
   *  otherwise returns false;
   */
  public static boolean noneCanReach(ArrayList<Position> queens)
  {
    ...
  }
}
