// Exam #4 Question 1

import java.util.ArrayList;

public class DNA
{
  /********************* Part (a) *********************/

  /** Checks whether str is a valid DNA string. Returns
   *  true if str contains only the letters A, C, G, or T;
   *  otherwise returns false.
   *  Precondition: str is not null and not empty.
   */
  public static boolean isValidDNA(String dna)
  {
    String DNAletters = "ACGT";

    for (int  i = 0; i < dna.length(); i++)
      if (DNAletters.indexOf(dna.substring(i, i+1)) < 0)
        return false;

    return true;
  }

  /********************* Part (b) *********************/
  
  /** Finds the first occurrence in a given DNA string of
   *  gene1 and gene2. Returns the gap between the matched
   *  genes if they are found in the correct order with no
   *  overlap; otherwise returns -1.
   *  Precondition: gene1 and gene2 are non-empty strings.
   */
  public static int matchTwoGenes(String dna, String gene1, String gene2)
  {
    int i1 = dna.indexOf(gene1);
    if (i1 < 0)
      return -1;

    int i2 = dna.indexOf(gene2);
    if (i2 < i1 + gene1.length())
      return -1;

    return i2 - i1 - gene1.length();
  }
  
  /*********************  Extra  *********************/

  /** Finds the first occurrence in a given DNA string of
   *  each of the genes from a given array of genes and
   *  returns the sum of the gaps between the matched genes.
   *  Returns the sum of the gaps between the matched genes
   *  or -1 if one of the genes is not found or is found out
   *  of order or overlaps with one of the previously matched genes.
   *  Precondition: genes.length > 0; every gene in the array
   *                genes is a non-empty string
   */
  public static int matchGenes(String dna, ArrayList<String> genes)
  {
    ...
  }
}